#include <Application.h>
#include <MidiPort.h>
#include <stdio.h>

class MIDIToy : public BApplication
{
	public:
		MIDIToy();
		virtual ~MIDIToy();
		
		virtual void ReadyToRun();
		
};

int main( int argc, char **argv )
{
	MIDIToy *toy = new MIDIToy();
	
	toy->Run();
	
	delete toy;
	
	return 0;
}

MIDIToy::MIDIToy()
	: BApplication( "application/x-vnd.goingware-miditoy" )
{
	return;
}

MIDIToy::~MIDIToy()
{
	return;
}

void MIDIToy::ReadyToRun()
{
	BMidiPort p;
	
	char name[ B_OS_NAME_LENGTH ];
	
	p.GetDeviceName( 0, name, B_OS_NAME_LENGTH );
	
	printf( "MIDIToy: found MIDI device %s\n", name );
	
	status_t stat = p.Open( name );
	
	if ( stat != B_OK ){
		printf( "MIDIToy: error opening port status=0x%x\n", stat );
		PostMessage( B_QUIT_REQUESTED );
		return;
	}
	
	for (int i = 0; i < 128; i++) {
	    p.NoteOn(1, i, 80);
	    snooze(50000);
	    p.NoteOff(1, i, 80);
	}
	
	printf( "MIDIToy: quitting\n" );

	PostMessage( B_QUIT_REQUESTED );
	return;
}
	